Skip to main content Skip to footer

How to Add a Smart JavaScript Data Table Component to Your Web Application

Quick Start Guide
What You Will Need
  • VisualStudio Code
  • Wijmo
  • Grid.js
Controls Referenced

Wijmo FlexGrid

FlexGrid Export

Tutorial Concept Enable fast sorting, filtering, and responsive layouts with a smart JavaScript Data Table component to facilitate cleaner, more interactive data experiences.

Tables are an essential part of modern web applications because they provide one of the most efficient ways to present, compare, and organize large datasets. While plain HTML tables can handle simple use cases, they quickly become difficult to manage when your project demands interactivity, performance, or flexibility.

At that point, developers face a choice: they can either build and maintain custom table logic, writing all the sorting, filtering, and editing features themselves, or they can use a dedicated JavaScript data grid that already solves these challenges. The first option often leads to increased maintenance and distraction from the project's core goals. The second option leverages proven, optimized solutions built for scalability and enterprise use.

Data tables are used everywhere, from dashboards and financial reports to sales tracking tools and spreadsheets (like web apps). With this widespread demand, the ecosystem of JavaScript UI components has grown to include specialized, high-performance grids designed to handle complex data scenarios.

Today's smart JavaScript data grids do far more than display information. They provide advanced functionality out of the box, such as data binding, virtualization, sorting, filtering, grouping, and flexible editing options, all with minimal setup.

In this article, we'll look at what makes a data grid "smart," review an open-source example, and show how to build an enterprise-grade solution using Wijmo's FlexGrid, a powerful JavaScript data grid from MESCIUS. We'll cover the following sections:

Ready to get started? Download Wijmo Today!

Table Capabilities

How smart can a smart table be? Just adding a few features to a plain HTML table is not enough. Current products in the market can vary greatly, but there are some key features that people expect to see when they look for a smart data table:

  • Data features:
    • Import data from and export to various sources, including local files (such as Excel import and export), databases, and APIs
    • Searching, filtering, and sorting options
    • Load and display large datasets with pagination
  • UI features:
    • Showing and hiding columns
    • Inline editing
    • Responsiveness: built-in support for desktop and mobile
    • Resizable columns to accommodate long data points or multiline comments
    • Horizontal and vertical scroll support
    • Data validation and visualizations, such as sparklines

Some frameworks have built-in implementations with a few features, but you have to code advanced features requiring unplanned development effort.

Using JavaScript Data Tables

When you're building a web app with plain JavaScript (rather than a framework-specific layer), you still face the table challenge: displaying, sorting, filtering, and managing tabular data in ways that go beyond a static HTML table. Fortunately, the open-source ecosystem in JavaScript offers mature table/grid libraries that handle most of the heavy lifting.

Here are some popular open-source JavaScript table/grid solutions worth evaluating:

  • DataTables — A long-time favorite for enhancing existing HTML <table> elements: adds searching, pagination, multi-column sorting, framework integrations, and lots of extensions.
  • Grid.js — A lightweight, framework-agnostic JavaScript table plugin that works with vanilla JavaScript (or frameworks) and supports async data, custom cell rendering, sorting, pagination, and extension via a pipeline.
  • Tabulator — A fully featured JS data-grid library offering virtual DOM rendering for large datasets, exporting (CSV/XLSX), tree/hierarchical views, touch-support, persistent state, and spreadsheet-style behavior.

When selecting a JavaScript table library, keep these questions in mind:

  • Does it support large datasets (via virtualization or paging) to ensure acceptable performance?
  • Are the sorting, filtering, selection, and editing features you need built in or easy to extend?
  • Is the API intuitive for vanilla JavaScript (rather than requiring you to adopt a framework)?
  • How good is the documentation, community support, and plugin/extension ecosystem?
  • Does the library integrate easily with your data source (JSON, REST, streaming) and your UI design/style?

In the next section, we'll evaluate one of these libraries in more detail, and then show how you can implement an enterprise-grade, smart JavaScript data table using FlexGrid from Wijmo, a high-performance solution with advanced features built for production use.

Implementing a JavaScript App with Grid.js

The different open-source projects listed above have advantages and disadvantages. Depending on which features you're looking for, some of these components will score higher than others, so let's just demonstrate one of them.

We'll implement a new JavaScript application with a Grid.js table, an open-source component that closely resembles the smart data table that will be implemented in the end.

First, create a new file, which we'll call index.html, and we'll reference the required Grid.js files that we'll need via their CDN:

<script src="https://cdn.jsdelivr.net/npm/gridjs/dist/gridjs.umd.js"></script>
<link href="https://cdn.jsdelivr.net/npm/gridjs/dist/theme/mermaid.min.css" rel="stylesheet" />

Then, inside the <body> tag, we'll add an element to which we can bind our data table, as well as a pair of <script> tags which we'll use to generate some data:

<div id="datatable"></div>
<script>
    function getData() {
        var data = [];
        var countries = ['US', 'UK', 'Germany', 'France', 'Mexico', 'Canada', 'China', 'Japan', 'South Korea', 'India']
        for(var i = 0; i < 10; i++) {
            data.push({
                id: i,
                country: countries[i],
                sales: Math.round(Math.random() * 10000),
                downloads: Math.round(Math.random() * 25000),
                expenses: Math.round(Math.random() * 1500)
            });
        }
        return data;
    }
</script>

The getData() function creates an array called data and then uses a for() loop to generate data objects, which are pushed onto the array. Then, we simply return the array.

Now, inside the <script> tags, we'll add the code required to add a Grid.js data table to the application and bind it to our datatable element:

<script>
    function getData() {
        var data = [];
        var countries = ['US', 'UK', 'Germany', 'France', 'Mexico', 'Canada', 'China', 'Japan', 'South Korea', 'India']
        for(var i = 0; i < 10; i++) {
            data.push({
                id: i,
                country: countries[i],
                sales: Math.round(Math.random() * 10000),
                downloads: Math.round(Math.random() * 25000),
                expenses: Math.round(Math.random() * 1500)
            });
        }
        return data;
    }
    var dataTable = new gridjs.Grid({
        columns: ['ID', 'Country', 'Sales', 'Downloads', 'Expenses'],
        data: getData()
    }).render(document.getElementById('datatable'));
</script>

Now, if we run the application, we'll see the Grid.js data table in the browser:

JavaScript Data Table

To demonstrate some of the component features of this open-source grid, we'll also show off how you can add formatting to cells, both to change the content of what's being displayed and to style the contents of the cells.

Inside the data grid initialization, we'll alter how we set up the columns property so that we can modify how the Sales and Expenses columns display their data, as well as add some conditional formatting to the Downloads column.

Update the dataTable variable that we created so that it looks as follows:

var dataTable = new gridjs.Grid({
    columns: [
        'ID',
        'Country',
        {
            name: 'Sales',
            formatter: (cell) => `$${cell}`
        },
        {
            name: 'Downloads',
            formatter: (cell) => {
                if(cell < 10000) {
                    return gridjs.html(`<b style="color: red">${cell}</b>`);
                } else if(cell > 17500) {
                    return gridjs.html(`<b style="color: green">${cell}</b>`);
                }
                return gridjs.html(`${cell}`);
            }
        },
        {
            name: 'Expenses',
            formatter: (cell) => `$${cell}`
        }
    ],
    data: getData()
}).render(document.getElementById('datatable'));

The columns array accepts both strings and objects, so we're creating objects for the Sales, Downloads, and Expenses columns. We give each of them a name, and then we use the formatter property to create an array that can be used to style that column. For Sales and Expenses, we're adding a dollar sign ($) to indicate that these are currency values. For Downloads, we're checking the cell value. Any cell with a value less than 10,000 gets bolded and colored red, while a value greater than 17,500 gets bolded and colored green. Now, when we run the application, we'll see the following in the browser:

Formatted JavaScript Data Table

Now we have a data table that can both add formatting and do it conditionally based on cell values. This is great; however, there are still some problems that Grid.js, as well as the other open source options we've highlighted, share.

First, there's the problem of editing. While you can do things like sorting and formatting with these grids, an important feature of a smart data table is the ability to edit the contents of the grid. These are great for viewing data, but if you want to give your users the power of a true smart data table, they'll need to be able to work with the data, not just view it.

Second, modifying or adding a few lines to customize a single data table doesn't seem to be a big problem. However, when you have different smart tables implemented on numerous pages across multiple projects, it becomes evident that your organization needs a more robust and consistent solution.

Alternatives to Customizing Open-Source JavaScript Data Tables

For everyday use, open-source smart table components are sufficient to fulfill basic needs and do the work. However, if your company is developing first-rate, enterprise-grade applications, you should consider more professional products that offer support for multiple JavaScript frameworks and cover a comprehensive set of functionalities.

MESCIUS offers several data table products that can be easily implemented in a JavaScript app with just a few lines of code. These products are packed with a rich set of features that we would otherwise have to customize, just like we did previously with the open-source component.

Let's explore some highlights from different lightweight smart table products provided by MESCIUS, including SpreadJS, DataViewJS, and Wijmo's FlexGrid.

SpreadJS

SpreadJS is the World's best-selling JavaScript Spreadsheet with over 450 Excel functions. With SpreadJS, you can quickly deliver Excel-like spreadsheet experiences with zero dependencies on Excel, along with full support for React, Vue, Angular, and TypeScript.

For standard spreadsheet scenarios, SpreadJS enables you to create financial reports and dashboards, budgeting and forecasting models, science lab notebooks, and scientific, engineering, healthcare, education, and other similar JavaScript applications.

For more advanced spreadsheet use cases, SpreadJS allows you to create custom spreadsheets, advanced grids, dashboards, reports, and data input forms with the comprehensive API. Powered by a high-speed calculation engine, SpreadJS enables the most complex calculations.

SpreadJS enables integration by importing and exporting features that work seamlessly with the most demanding Excel spreadsheets. 

DataViewJS

DataViewJS is a data grid platform focused on advanced data presentation. It goes beyond traditional tabular displays, providing several presentation views, including tree, card, masonry, trellis, timeline, Gantt, calendar, and grid.

DataViewJS allows you to change layouts freely with a single line of code and has full support for Angular, React, and Vue.js.

Wijmo FlexGrid

FlexGrid is part of the Wijmo product family, which includes JavaScript/HTML5 UI components, such as FlexChart, Input, PivotChart, FinancialChart, ReportViewer, and more. FlexGrid has full support for Angular, React, Vue, Nuxt.js, Next.js, and Svelte.

Its lightning speed and extensibility make Wijmo's FlexGrid the ultimate JavaScript smart data grid. FlexGrid's small footprint improves performance and reduces load time by keeping your web applications compact.

You can take advantage of the Excel-like features of FlexGrid, such as data aggregation, cell merging, star sizing, and cell freezing. Also, Cell Templates provide limitless templates with support for declarative markup and binding expressions.

Each of these MESCIUS products is lightweight and works with virtualization, meaning they keep running at high performance even when connected to massive data sources.

A JavaScript Smart Data Table with Wijmo FlexGrid

Let's demonstrate how to implement a Wijmo FlexGrid smart JavaScript data table in the same JavaScript app we previously built.

Just like with Grid.js, we'll be using Wijmo's CDN to import the required files:

<link href="https://cdn.mescius.com/wijmo/5.latest/styles/wijmo.min.css" rel="stylesheet"/>
<script src="https://cdn.mescius.com/wijmo/5.latest/controls/wijmo.min.js"></script> 
<script src="https://cdn.mescius.com/wijmo/5.latest/controls/wijmo.grid.min.js"></script>

These imports are Wijmo's core CSS file, its core JavaScript file, and then FlexGrid's JavaScript file.

Then, we just need to replace Grid.js' initialization inside the <script> tag with Wijmo FlexGrid's initialization:

var dataTable = new wijmo.grid.FlexGrid('#datatable', {
    itemsSource: getData()
});

Now, when we run the application, we'll see the FlexGrid in the browser:

JavaScript datagrid

The first thing you'll notice is the highlighted cell; Wijmo's FlexGrid allows you to easily select both individual cells and cell ranges, and comes with editing out of the box. Simply select a cell and start typing to update the cell value:

JavaScript datagrid editing

You can also see in the header column an editing icon displayed to show which row we're currently working on.

Wijmo's FlexGrid also comes with several features that are available without requiring any implementation. Your users will be able to sort columns by simply clicking on the column header, and they'll also be able to reorder the layout of their columns by dragging and dropping them where they'd like:

JavaScript datagrid sorting

Custom and Conditional Formatting

Now, like with Grid.js, we'll apply some formatting to some of these columns. First, we're going to add some formatting to the Sales and Expenses columns:

var dataTable = new wijmo.grid.FlexGrid('#datatable', {
    autoGenerateColumns: false,
    columns: [
        { header: 'ID', binding: 'id' },
        { header: 'Country', binding: 'country' },
        { header: 'Sales', binding: 'sales', format: 'c2' },
        { header: 'Downloads', binding: 'downloads' },
        { header: 'Expenses', binding: 'expenses', format: 'c2' }
    ],
    itemsSource: getData()
});

Like with open-source grids, we're binding the objects for our columns to a columns array. However, unlike the others, we can easily format our data with strings; in this case, the string 'c2'. The 'c' stands for currency, while the numeric value is the number of decimal places we're going to display.

Currency is not the only formatting type available in FlexGrid; there are also percentage, numeric, float, and more.

Next, we'll format the Downloads column in the same style as we did with Grid.js:

var dataTable = new wijmo.grid.FlexGrid('#datatable', {
    autoGenerateColumns: false,
    columns: [
        { header: 'ID', binding: 'id' },
        { header: 'Country', binding: 'country' },
        { header: 'Sales', binding: 'sales', format: 'c2' },
        { header: 'Downloads', binding: 'downloads' },
        { header: 'Expenses', binding: 'expenses', format: 'c2' }
    ],
    itemsSource: getData(),
    itemFormatter: (panel, r, c, cell) => {
        if(c == 3 && panel.getCellData(r, c) < 10000) {
            cell.style.color = 'red';
            cell.style.fontWeight = 'bold';
        } else if(c == 3 && panel.getCellData(r, c) > 17500) {
            cell.style.color = 'green';
            cell.style.fontWeight = 'bold';
        }
    }
});

As you can see, we're using a property called itemFormatter, which accepts a function with four arguments: panel, c, r, and cell. For the purposes of this sample, we only need to worry about c and r, which represent the column and row value, while cell is the HTMLElement of the cell we're working in.

All we're doing here is checking to see if we're in the Downloads column (which would be column 3, since arrays start at index 0), and we're checking the value against our preset values: in this case, 10,000 and 17,500. If they are, we simply set the appropriate CSS values based on where they fall within our conditional styling guidelines.

Now, when we run the application, we should see the following:

JavaScript datagrid conditional formatting

The last thing that we'll do is give users the ability to export their data table to an XLSX file. To do so, we'll need to import the required file from the CDN that will allow us to export our data, as well as add a button and bind a method to its click event:

<script src="https://cdn.mescius.com/wijmo/5.latest/controls/wijmo.grid.xlsx.min.js"></script>
...
<button id="saveXlsx" type="button" class="btn btn-primary" onclick="exportXlsx()">Export</button>

Then, we'll create the exportXlsx() method that will actually handle the export:

function exportXlsx() {
    var workBook = wijmo.grid.xlsx.FlexGridXlsxConverter.save(dataTable, {
        includeColumnHeaders: true,
        includeStyles: true
    }, 'FlexGrid.xlsx');
}

Now, when we run the application, we'll see the following:

JavaScript datagrid export

And when we click the Export button, the data table will get exported into an XLSX file, which, when opened, should look like so:

JavaScript datagrid XLSX

This demo barely scratches the surface of the FlexGrid component. You can explore the MESCIUS page for the Wijmo family of JavaScript UI Components and Tools to find complete documentation, demos, and examples written for Angular, React, and Vue.

Ready to check it out? Download Wijmo Today!

Conclusion

You can create and use JavaScript-based smart data tables in many different ways. Since JavaScript is the foundation of most modern web frameworks, developers have the freedom to choose between lightweight libraries, UI component suites, or fully featured grid controls. However, not all solutions are equal, and some require extensive manual configuration and customization to achieve the desired level of interactivity or performance. Often, you don't realize how much work is involved until you've already invested significant development time.

There are many free and open-source table libraries available that are great for common data display needs. We reviewed several of these options earlier in this article. However, for business or enterprise-grade applications, developers shouldn't have to build complex functionality from scratch or maintain endless workarounds to meet production requirements. That's where a commercial, professionally supported component suite like Wijmo provides real value and long-term efficiency.

Wijmo's FlexGrid is built with a framework-agnostic JavaScript core that delivers consistent, high-performance behavior across the entire ecosystem. It includes full support for popular frameworks like Angular, React, and Vue, while maintaining the same underlying grid engine and API. This consistency gives developers the freedom to choose their preferred framework — or even migrate between them — without needing to rebuild their data grid from scratch. The result is faster development, improved maintainability, and a greater return on investment for your organization.

Tags:

comments powered by Disqus

Skip to main content Skip to footer

How to Add a Smart Angular Data Table Component to Your Web Application

Quick Start Guide
What You Will Need

Wijmo

Angular

Controls Referenced

FlexGrid

Tutorial Concept Creating a Smart Data Table in Angular - Use Wijmo's FlexGrid control to create a feature-rich, modern Angular data table.

Tables are prevalent in web products because they're one of the easiest ways to present and organize complex data. Plain HTML tables will solve the most common use-case scenarios, but trying to do anything sophisticated with them will quickly frustrate you.

This is when developers should make a decision. They either start coding tables in an old-fashioned way by creating HTML tables and adding enhancements by themselves — at the risk of losing focus of their project — or look for existing market products that already solve those problems.

Many companies use data tables to show complex reports, dashboards, financial data, sales results, and even interactive spreadsheets. With high demand came specialized supply, so tables are ubiquitous assets in web component libraries.

Today, there are dedicated smart Angular data table controls that handle the table part for you and provide additional features, including selection modes, sorting, and column reordering.

Try all of Wijmo's specialized controls with the Enterprise trial! Download it today!

This article describes which capabilities are expected from a smart table, evaluates an open-source project, and demonstrates how to implement enterprise-grade, smart data tables with Wijmo's FlexGrid, a MESCIUS Angular data table solution. We will explore the following sections:

Table Capabilities

How smart can a smart table be? Just adding a few features to a plain HTML table is not enough. Current products in the market can vary greatly, but there are some key features that people expect to see when they look for a smart data table:

  • Data features:
    • Import data from and export to various sources, including local files (such as Excel import and export), databases, and APIs
    • Searching, filtering, and sorting options
    • Load and display large datasets with pagination
  • UI features:
    • Showing and hiding columns
    • Inline editing
    • Responsiveness: built-in support for desktop and mobile
    • Resizable columns to accommodate long data points or multiline comments
    • Horizontal and vertical scroll support
    • Data validation and visualizations, such as sparklines

Some frameworks have built-in implementations with a few features, but you have to code advanced features requiring unplanned development effort.

Using Angular Data Tables

Maintained by Google and with contributions from individual developers and companies, Angular is an open-source, front-end web application platform based on TypeScript.

Unlike other lightweight JavaScript libraries, Angular is a complete application design framework for sophisticated single-page applications (SPA). Angular apps are built on an opinionated architecture, which means that apps must be written around some conventions and good practices to work correctly.

Angular's robust architecture is one of the main reasons many mid to large companies have adopted this framework. With such a strong adoption in the enterprise area, multiple open source communities and third-party vendors have created productivity components for Angular-based businesses.

Some popular open-source smart data table libraries made for Angular include:

Implementing an Angular App with ngx-datatable

The different open-source projects listed above have advantages and disadvantages. Depending on which features you’re looking for, some of these components will score higher than others, so let's just demonstrate one of them.

We’ll implement a new Node-based, Angular application with ngx-datatable, an open-source component with a look-and-feel close to the smart table we're going to demonstrate in the end.

First, install Node.js. Next, using a command-line console, create a new Node app and move to its folder:

ng new smart-angular-data-table --no-standalone

The install wizard will ask you a few questions:

Style format selection Angular CLI

No SSR Angular CLI

 

Navigate into the application:

cd smart-angular-data-table

Install the angular package...

npm i @angular/core

...and run your new application:

npm start

Your app should look something like this:

Default Angular App

 

Now, we need to install the ngx-datatable and the bootstrap packages:

npm i @swimlane/ngx-datatable
npm i bootstrap

Create a new folder named data under the src folder, and create a new file named data.js. These data represent sales information that will be used to populate our data grid:

export const recentSales = [
{
  id: 1,
  country: "Canada",
  soldBy: "Bill",
  client: "Cerberus Corp.",
  description: "Prothean artifacts",
  value: 6250,
  itemCount: 50
},
{
  id: 2,
  country: "Canada",
  soldBy: "Bill",
  client: "Strickland Propane",
  description: "Propane and propane accessories",
  value: 2265,
  itemCount: 20
},
{
  id: 3,
  country: "USA",
  soldBy: "Ted",
  client: "Dunder Mifflin",
  description: "Assorted paper-making supplies",
  value: 4700,
  itemCount: 10
},
{
  id: 4,
  country: "USA",
  soldBy: "Ted",
  client: "Utopia Planitia Shipyards",
  description: "Dilithium, duranium, assorted shipbuilding supplies",
  value: 21750,
  itemCount: 250
},
{
  id: 5,
  country: "USA",
  soldBy: "Ted",
  client: "Glengarry Estates",
  description: "Desks, phones, coffee, steak knives, and one Cadillac",
  value: 5000,
  itemCount: 5
},
{
  id: 6,
  country: "Germany",
  soldBy: "Angela",
  client: "Wayne Enterprises",
  description: "Suit armor and run-flat tires",
  value: 35000,
  itemCount: 25
},
{
  id: 7,
  country: "Germany",
  soldBy: "Angela",
  client: "Stark Industries",
  description: "Armor and rocket fuel",
  value: 25000,
  itemCount: 10
},
{
  id: 8,
  country: "Germany",
  soldBy: "Angela",
  client: "Nakatomi Trading Corp.",
  description: "Fire extinguishers and replacement windows",
  value: 15000,
  itemCount: 50
},
{
  id: 9,
  country: "UK",
  soldBy: "Jill",
  client: "Spaceley Sprockets",
  description: "Anti-gravity propulsion units",
  value: 25250,
  itemCount: 50
},
{
  id: 10,
  country: "UK",
  soldBy: "Jill",
  client: "General Products",
  description: "Ion engines",
  value: 33200,
  itemCount: 40
}];

Add a new opensource-demo folder under the app folder, and create three new files named opensource-demo.css, opensource-demo.html, and opensource-demo.ts. These files will hold the stylesheet, HTML, and the TypeScript code necessary for our new component:

/smart-angular-data-table
  /src
    /app
      /opensource-demo
        opensource-demo.css
        opensource-demo.html
        opensource-demo.ts

Open the opensource-demo.css file and add the imports below. This will apply the stylesheets required by the open-source component:

@import "../../../node_modules/@swimlane/ngx-datatable/themes/bootstrap.css";
@import "../../../node_modules/@swimlane/ngx-datatable/assets/app.css";
@import 'bootstrap/dist/css/bootstrap.css';

Open the opensource-demo.ts file and add the TypeScript code below. Here, we import the sales data, export our demo class, and declare the Angular state variable that will be used by the data grid as the component's data source:

import { Component, ViewEncapsulation } from '@angular/core';
import { recentSales } from "../../data/data"

@Component({
  selector: 'app-root',
  styleUrls: ['opensource-demo.css'], 
  encapsulation: ViewEncapsulation.None,
  templateUrl: 'opensource-demo.html'
})
export class OpenSourceDemo {
  rows = recentSales;
}

Open the opensource-demo.html file and add the code to include the ngx-datatable component:

<div class="card main-panel">
    <div class="card-header">
        <h1>Open Source Demo</h1>
    </div>
    <div class="card-body">
        <div class="container-fluid">
            <ngx-datatable
              class="bootstrap"
              [rows]="rows"
              [headerHeight]="50"
              [rowHeight]="40">
              <ngx-datatable-column name="Id" prop="id"></ngx-datatable-column>
              <ngx-datatable-column name="Country" prop="country"></ngx-datatable-column>
              <ngx-datatable-column name="Sold By" prop="soldBy"></ngx-datatable-column>
              <ngx-datatable-column name="Client" prop="client">
              </ngx-datatable-column>        
              <ngx-datatable-column name="Description" prop="description">
              </ngx-datatable-column>
              <ngx-datatable-column name="Value" prop="value"></ngx-datatable-column>
              <ngx-datatable-column name="Item Count" prop="itemCount"></ngx-datatable-column>        
            </ngx-datatable>
        </div>
    </div>
</div>

Edit the app.module.ts file located in the src\app folder and replace its contents with the lines below. Notice how the NgxDatatableModule is imported to provide our demo with the open-source components:

import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { OpenSourceDemo } from './opensource-demo/opensource-demo';

// import NgxDatatable modules
import { NgxDatatableModule } from '@swimlane/ngx-datatable';

@NgModule({
  declarations: [
    OpenSourceDemo
  ],
  imports: [
    BrowserModule,
    NgxDatatableModule
  ],
  providers: [],
  bootstrap: [OpenSourceDemo]
})
export class AppModule { }

Once the app is running, you’ll see the ngx-datatable component displaying the sales data:

Open Source Demo

To show some of the component features, let’s start customizing our open-source data grid to support cell value updates.

Implementing Cell Value Update

The ngx-datatable project supports updating cell values, but it’s not provided out of the box. To use this feature, you must follow a few steps to implement it.

First, open the opensource-demo.ts file and include the updateValue function in the OpenSourceDemo class. The ngx-datatable component will invoke this function whenever the user finishes editing a cell value:

export class OpenSourceDemo {
  editing = {};
  rows = recentSales;

  updateValue(event, cell, rowIndex) {
      this.editing[rowIndex + '-' + cell] = false;
      this.rows[rowIndex][cell] = event.target.value;
      this.rows = [...this.rows];
  }
}

Modify the opensource-demo.html file to make the Client and Description columns editable:

<ngx-datatable-column name="Client" prop="client">
    <ng-template ngx-datatable-cell-template let-rowIndex="rowIndex" let-value="value" let-row="row">
        <span title="Double click to edit"
        (dblclick)="editing[rowIndex + '-client'] = true"
        *ngIf="!editing[rowIndex + '-client']"
        >{{value}}
        </span>
        <input
        autofocus
        (blur)="updateValue($event, 'client', rowIndex)"
        *ngIf="editing[rowIndex + '-client']"
        type="text"
        [value]="value"
        />
    </ng-template>
</ngx-datatable-column>        
<ngx-datatable-column name="Description" prop="description">
    <ng-template ngx-datatable-cell-template let-rowIndex="rowIndex" let-value="value" let-row="row">
        <span title="Double click to edit"
        (dblclick)="editing[rowIndex + '-description'] = true"
        *ngIf="!editing[rowIndex + '-description']"
        >{{value}}
        </span>
        <input
        autofocus
        (blur)="updateValue($event, 'description', rowIndex)"
        *ngIf="editing[rowIndex + '-description']"
        type="text"
        [value]="value"
        />
    </ng-template>            
</ngx-datatable-column>

As we can see, the code above uses the dblclick event handler to tell ngx-datatable to open the text editor when the cell is double-clicked and to tell the blur event handler to update the cell value when the user finishes editing.

These changes allow our ngx-datatable to handle updates on the Client and Description columns and persist them in the underlying data source:

Client Column

Modifying or adding a few lines to customize a single data table doesn’t seem to be a big problem. However, when you have different smart tables implemented on numerous pages across multiple projects, it becomes evident that your organization needs a more robust and consistent solution.

Alternatives to Customizing Open Source Angular Data Tables

For everyday use, open-source smart table components do the work and are enough to fulfill basic needs. However, if your company is developing first-rate, enterprise-grade applications, you should look into more professional products that offer support for multiple JavaScript frameworks and cover a complete set of functionalities.

MESCIUS provides several data table products that can be implemented in an Angular app with a few code lines. These products are packed with a rich set of features that we would otherwise have to customize, just like we did previously with the open-source component.

Let’s explore some highlights from different lightweight smart table products provided by MESCIUS, including SpreadJS, DataViewJS, and Wijmo's FlexGrid.

SpreadJS

SpreadJS is the World's best-selling JavaScript Spreadsheet with over 450 Excel functions. With SpreadJS, you can quickly deliver Excel-like spreadsheet experiences with zero dependencies on Excel, along with full support for React, Vue, Angular, and TypeScript.

For standard spreadsheet scenarios, SpreadJS enables you to create financial reports and dashboards, budgeting, and forecasting models, scientific, engineering, healthcare, education, science lab notebooks, and other similar JavaScript applications.

For more advanced spreadsheet use cases, SpreadJS allows you to create custom spreadsheets, advanced grids, dashboards, reports, and data input forms with the comprehensive API. Powered by a high-speed calculation engine, SpreadJS enables the most complex calculations.

SpreadJS enables integration by importing and exporting features that work seamlessly with the most demanding Excel spreadsheets. 

DataViewJS

DataViewJS is a Datagrid platform focused on advanced data presentation. It goes beyond traditional tabular displays providing several presentation views, including tree, card, masonry, trellis, timeline, Gantt, calendar, and grid.

DataViewJS allows you to change layouts freely with a single line of code and has full support for Angular, React, and Vue.js.

Wijmo FlexGrid

FlexGrid is part of the Wijmo product family which includes JavaScript/HTML5 UI components, such as FlexChart, Input, PivotChart, FinancialChart, ReportViewer, and more. FlexGrid has full support for Angular, AngularJS, ReactJS, VueJS, and Knockout.

Its lightning speed and extensibility make Wijmo's FlexGrid the ultimate JavaScript smart data grid. FlexGrid’s small footprint improves performance and reduces load time by keeping your web applications compact.

You can take advantage of the Excel-like features of FlexGrid, such as data aggregation, cell merging, star sizing, and cell freezing. Also, Cell Templates provide limitless templates with support for declarative markup and binding expressions.

Each of these MESCIUS products is lightweight and works with virtualization, meaning they keep running at high performance even when connected to massive data sources.

An Angular Smart Data Table with Wijmo FlexGrid

Let’s demonstrate how to implement a Wijmo FlexGrid smart Angular data table in the same Node.JS app we previously built.

First, install the Wijmo package with npm:

npm install @mescius/wijmo.angular2.all

Add a new flexgrid-demo folder under the app folder, and create three new files named flexgrid-demo.css, flexgrid-demo.html, and flexgrid-demo.ts:

/smart-angular-data-table
  /src
    /app
      /flexgrid-demo
        flexgrid-demo.css
        flexgrid-demo.html
        flexgrid-demo.ts

Open the flexgrid-demo.ts file and add the following lines to import the Wijmo FlexGrid modules and export our FlexGridDemo component:

import { Component, NgModule, ViewChild, ViewEncapsulation } from '@angular/core';

// import Wijmo components
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.grid';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { recentSales } from "../../data/data"

@Component({
  selector: 'app-root',
  templateUrl: 'flexgrid-demo.html',
  styleUrls: ['flexgrid-demo.css'], 
  encapsulation: ViewEncapsulation.None
})
export class FlexGridDemo {
  sales: any[];
  
  // references FlexGrid named 'flex' in the view
  @ViewChild('flex') flex: wjcGrid.FlexGrid;

  // DataSvc will be passed by derived classes
  constructor() {
      this.sales = recentSales;
  }
}

Open flexgrid-demo.html and add the code below to implement the wj-flex-grid and wj-flex-grid-column components:

<div class="card main-panel">
  <div class="card-header">
      <h1>Wijmo FlexGrid Demo</h1>
  </div>
  <div class="card-body">
    <div class="container-fluid">
      <wj-flex-grid #flex
          [itemsSource]="sales">
          <wj-flex-grid-column [header]="'ID'" [binding]="'id'" [width]="50"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Client'" [binding]="'client'" [width]="150"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Description'" [binding]="'description'" [width]="320"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Value'" format="n2" [binding]="'value'" [width]="100"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Quantity'" format="n0" [binding]="'itemCount'" [width]="100"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Sold By'" [binding]="'soldBy'" [width]="100"></wj-flex-grid-column>
          <wj-flex-grid-column [header]="'Country'" [binding]="'country'" [width]="100"></wj-flex-grid-column>
      </wj-flex-grid>
    </div>
  </div> 
</div>

Modify the app.module.ts file to import and reference our new FlexGridDemo component:

import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { OpenSourceDemo } from './opensource-demo/opensource-demo';
import { FlexGridDemo } from './flexgrid-demo/flexgrid-demo';

// import NgxDatatable modules
import { NgxDatatableModule } from '@swimlane/ngx-datatable';

// import Wijmo modules
import { WjGridModule } from '@mescius/wijmo.angular2.grid';

// apply Wijmo license key
import { setLicenseKey } from '@mescius/wijmo';
setLicenseKey('your license key goes here');

@NgModule({
  declarations: [
    OpenSourceDemo,
    FlexGridDemo
  ],
  imports: [
    BrowserModule,
    WjGridModule,
    NgxDatatableModule
  ],
  providers: [],
  // bootstrap: [OpenSourceDemo]
  bootstrap: [FlexGridDemo]
})
export class AppModule { }

Open the flexgrid-demo.css file and add the imports below. This will apply the stylesheets required by the FlexGridcomponent:

@import "@mescius/wijmo.styles/wijmo.css";
@import 'bootstrap/dist/css/bootstrap.css';

Now run the app:

npm start

Once the app is running, you’ll see the FlexGrid component displaying the sales data:

Wijmo Flexgrid Demo

Editing Grid Cell Values with FlexGrid

Cell editing is an out-of-the-box feature in FlexGrid. You can double-click the cells and start editing in place:

Cell Editing

By default, a FlexGridColumn is editable. However, you can disable editing by explicitly defining the isReadOnly property in the FlexGridColumn component:

<wj-flex-grid-column [header]="'ID'" [binding]="'id'" [width]="50" [isReadOnly]="true">
</wj-flex-grid-column>

Row Sorting with FlexGrid

By default, every FlexGrid column is sortable by ascending or descending order.

You can lock column sorting by setting the allowSorting property to false:

<wj-flex-grid-column [header]="'Client'" [binding]="'client'" [width]="150" [allowSorting]="false"></wj-flex-grid-column>

Column Reordering with FlexGrid

FlexGrid comes with the ability to reposition columns out of the box freely:

Reposition Column

Again, you can disable column reordering by setting the allowDragging property to false:

<wj-flex-grid-column [header]="'Client'" [binding]="'client'" [width]="150" [allowDragging]="false">
</wj-flex-grid-column>            

Importing Excel Data with FlexGrid

Let’s see how to import Excel data into our FlexGrid component.

First, append the following HTML segment after the card-body div in the render function:

<div className="card-body">
<div class="card-footer">	  
  <div class="input-group">
    <div class="custom-file">
      <input type="file" id="importFile"/>
    </div>
    <div class="input-group-prepend">
      <input type="button" value="Import"/>
    </div>
  </div>
</div> 

Run the application and notice the import section at the bottom of the page:

Import

Now, we should tell the Import button to import the file into our FlexGrid component. Add the onClick function to the input element and pass the name of the function as “load”:

<input type="button" value="Import" (click)="load()"/>

Then, add a new load function inside the component class in the flexgrid-demo.ts file. Here, we’ll first obtain the full path of the user-selected file:

load() {
    let fileInput = <HTMLInputElement>document.getElementById('importFile');
    if (fileInput.files[0]) {

    }
}

Now, add an import directive to the Wijmo libraries, which will handle the Excel functionalities we want to implement:

import * as wjcXlsx from '@mescius/wijmo.xlsx';
import * as wjcGridXlsx from '@mescius/wijmo.grid.xlsx';

Back to the load function—add a call to the loadAsync function of the Wijmo library to load the file’s contents into the FlexGrid:

load() {
    let fileInput = <HTMLInputElement>document.getElementById('importFile');
    if (fileInput.files[0]) {
        wjcGridXlsx.FlexGridXlsxConverter.loadAsync(this.flex, fileInput.files[0], { includeColumnHeaders: true });
    }
}

This functionality requires jszip to function, so install it with npm:

npm install jszip

Now, rerun the app and test the import feature.

npm start

Open Excel and create a new Demo.xlsx file with the following contents:

Create a New Demo

Back to our Angular app—click Choose File, choose Demo.xlsx, and click Import to see the result:

Wijmo Flexgrid Demo

Exporting Grid Data to Excel with FlexGrid

Finally, let’s see what’s needed to export data from our FlexGrid to Excel.

First, add the following HTML snippet after the Import button code to add a new Export button:

<div class="input-group-append">
  <input type="button" value="Export" (click)="save()"/>
</div>

Note that the click event handler is pointing to the save function. Let’s implement this function inside the component class:

save() {

}

To export FlexGrid data to an Excel file, we need to call the saveAsync function of the FlexGridXlsxConverter class:

save() {
  wjcGridXlsx.FlexGridXlsxConverter.saveAsync(this.flex,
    {
      includeColumnHeaders: true,
      includeCellStyles: false,
      formatItem: null
    },
    'FlexGrid.xlsx');
}

Run the app once again and test the export button:

Export

Now, you can open the Excel file exported by the FlexGrid component:

Excel File

This demo barely scratches the surface of the FlexGrid component. You can explore the MESCIUS page for the Wijmo family of JavaScript UI Components and Tools to find complete documentation, demos, and examples written for Angular, React, and Vue. Also, if you would like to see the example code for this demo, it can be found on GitHub. Additionally, you can find the code running here on StackBlitz.

Wrapping Up

You can create and use Angular-based smart data tables in various ways. Angular is a rich JavaScript framework and is relatively more complicated than competing JavaScript libraries, which is why some approaches require far more manual work than others. Still, you can’t tell the difference until you have already spent precious time customizing them.

There are plenty of free and open-source table libraries that are decent for everyday needs. We’ve seen how to implement one of them in this article. However, when it comes to business and enterprise projects, developers shouldn't be distracted by wasting their time developing workarounds, additional features, or configuration. This is why a commercial library component suite like Wijmo ensures a solid return on investment.

Built to be framework-agnostic, Wijmo includes full support for Angular, AngularJS, ReactJS, and VueJS, with the same grid across frameworks. This consistency across different libraries means freedom of choice and the ability to save time and development effort if your organization decides to migrate to another JavaScript framework.

Try all of Wijmo's specialized controls with the Enterprise trial! Download it today!

Tags:

comments powered by Disqus